/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "extern.h"

/**/U_DEFINE_STACK (strings_list, char*, 10)

int strings_current;

static add_line (start, len)
char *start;
int len;
{
	char *str = U_malloc (len + 1);
	int i;

	strncpy (str, start, len);
	U_stack_push_strings_list (str);

	*start = '#';
	*(start + 1) = 's';
	for (i = 2; i < len; i++)
		*(start + i) = ' ';
}

static add_line_holl (start, len)
char *start;
int len;
{
	char *orig_str, *str = U_malloc (2*len + 3), *cp;
	int i;

	orig_str = str;

	*str++ = '\'';

	cp = start;
	for (i = 0; i < len; i++)
		if (*cp == '\'') {
			*str++ = *cp++;
			*str++ = '\'';
		}
		else
			*str++ = *cp++;

	*str++ = '\'';
	*str = '\0';

	U_stack_push_strings_list (orig_str);

	*(start-1) = '#';
	*(start) = 's';
	for (i = 1; i < len; i++)
		*(start + i) = ' ';
}

static add_holl (line, len, hstart)
char **line, *hstart;
int len;
{
	(*line)++;

	for (; hstart < *line; hstart++)
		*hstart = ' ';

	add_line_holl (*line, len);
	*line = *line + len;
}

int is_just_decl (line, hstart)
char *line, *hstart;
{
	char *c;

	for (c = hstart - 1; c > line; c--)
		if (!iswhite (*c)) {
			if (*c == '*')
				return 1;
			else
				return 0;
		}

	return 0;
}

int is_just_label (line, hstart)
char *line, *hstart;
{
	char *c;

	for (c = hstart - 1; c > line; c--)
		if (!iswhite (*c) && !isdigit (*c))
			return 0;

	return 1;
}

/* state:
0: out
1: inside '
2: inside "
-1: outside '" and last is xalpha or white
-2: -1 followed by number
*/

int strings_find (line)
char *line;
{
	int state = 0, len, hlen, i;
	char *start, *hstart, chlen [9], *cp, *oline = line;

	for (;;) {

		switch (state) {

		case 0:
			if (!(is_xalpha (*line) || iswhite (*line)))
				state = -1;
			break;

		case -1:
			if (isdigit (*line)) {
				hstart = line;
				state = -2;
			}
			break;

		case -2:
			if (*line == 'h' || *line == 'H') {
				if (is_just_decl (oline, hstart)
				||  is_just_label (oline, hstart)) {
					state = 0;
					break;
				}

				cp = hstart;
				for (i = 0; cp < line; cp++)
					if (!iswhite (*cp))
						chlen [i++] = *cp;

				chlen [i] = '\0';

				hlen = atoi (chlen);
				add_holl (&line, hlen, hstart);
				state = 0;
				continue;
			}
			break;
		}

		if (state < 0) {
			if (is_xalpha (*line))
				state = 0;
			else if (!(is_xalpha (*line) || iswhite (*line) || isdigit (*line)))
				state = -1;
		}

		switch (*line) {

		case '\'':
			switch (state) {
			case 0:
			case -1:
			case -2:
				start = line;
				len = 0;
				state = 1;
				break;
			case 1:
				if (*(line + 1) != '\'') {
					add_line (start, ++len);
					state = 0;
				}
				else {
					line = line + 2;
					len = len + 2;
					continue;
				}
				break;
			}
			break;

		case '"':
			switch (state) {
			case 0:
			case -1:
			case -2:
				start = line;
				len = 0;
				state = 2;
				break;
			case 2:
				if (*(line + 1) != '"') {
					add_line (start, ++len);
					state = 0;
				}
				else {
					line = line + 2;
					len = len + 2;
					continue;
				}
				break;
			}
			break;

		case '\n':
		case '\0':
			if (state > 0) {
				fatal ("non-terminated string");
				return 1;
			}
			else 
				return 0;

		case '#':
			if (state <= 0) {
				sprintf (serr, "'%c' ('\\%3o'): illegal character", '#', '#');
				fatal (serr);
				*line = 'X';  /* error recovery */
			}
			break;
		}

		if (state)
			len++;

		line++;
	}
}

char *strings_list_fun (i)
int i;
{
	return strings_list [i];
}
